import { apiBaseUrl } from "/common/config.js";

const request = async (
  options = {
    url: "",
    method: "",
    data: {},
    success: () => {},
    fail: () => {},
    complete: () => {},
  }
) => {
  return uni.request({
    url: `${apiBaseUrl}${options?.url}`,
    header: {
      "XX-Token": uni.getStorageSync("token"),
      "XX-Device-Type": "web",
    },
    method: options?.method ?? "GET",
    data: {
      uid: uni.getStorageSync("id"),
      ...options?.data,
    },
    success: (res) => {
      options?.success(res);
    },
    fail: (res) => {
      options?.fail(res);
    },
    complete: (res) => {
      options?.complete(res);
    },
  });
};
export default request;
